<?php
/**
 * backup.php	2015, 2017	-	Alessandro   http://edilweb.eu
 * 
 * esegue:
 * 	- backup database
 * 	- Check tables database
 * 	- backup files in .zip file
 *  - lista files compressi
 * 	- invia 2 mails ad Admin
 * Lo script  di libero uso, ma viene fornito come , senza garanzie o assunzioni di responsabilit.
 * 
 * This program is distributed in the hope that it will be useful - WITHOUT  
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or     
 * FITNESS FOR A PARTICULAR PURPOSE.  
 */

/*	Cartella iniziale 	*/
	define('RADICE', substr(__DIR__, 0, strripos(__DIR__, DIRECTORY_SEPARATOR)));
	
	date_default_timezone_set("Europe/Rome");
	
	ignore_user_abort(true);
	
	define('DIR_BAKUP', 'backup_sito');
	define("OUTPUT_DIR", RADICE . '/'.DIR_BAKUP.'/prote/');
	define('INCLUDE_DIR', RADICE . '/'.DIR_BAKUP.'/phpMailer520/');
	define('DUMP_PHP_DIR', RADICE . '/'.DIR_BAKUP. '/Ifsnop/Mysqldump/');
	
	include RADICE . '/'.DIR_BAKUP.'/prote/par.php';
	include RADICE . '/'.DIR_BAKUP.'/class.backup.php';


/*	 Instantiate Backup_Database and perform backup		*/
	$backupDatabase = new Backup_Database();
	
	$status = $backupDatabase->SystemDump();

	/*	Dump database with php	*/
	if ($status != 'OK'){

		include_once DUMP_PHP_DIR . 'Mysqldump.php';
		
		$dumpSettings = array(
				'exclude-tables' => array(),
				'compress' => Ifsnop\Mysqldump\Mysqldump::NONE,
				'no-data' => false,
				'add-drop-table' => true,
				'single-transaction' => true,
				'lock-tables' => true,
				'add-locks' => true,
				'extended-insert' => false,
				'disable-keys' => true,
				'skip-triggers' => false,
				'add-drop-trigger' => true,
				'routines' => true,
				'databases' => false,
				'add-drop-database' => false,
				'hex-blob' => true,
				'no-create-info' => false,
				'where' => ''
		);

		$dump = new Ifsnop\Mysqldump\Mysqldump( $backupDatabase->dsn, 
												$backupDatabase->username, 
												$backupDatabase->passwd, 
												$dumpSettings);
		

		try{
			$backupDatabase::$phpDumpExecute = true;
			$dump->start($backupDatabase::$dbNameSqlPhp);
		}
		catch (Exception $e){
			$e->getMessage();
			$backupDatabase::$phpDumpError = $e;
		}
		catch (PDOException $f){
			$f->getMessage();
			$backupDatabase::$PDOdumpError = $f;
		}
	}

	
	echo '<h3>Dump database eseguito ...</h3>';
	ob_flush(); flush();
		
	
/*	Check tabelle	*/	
	$backupDatabase->Ottimizza_Tabelle();
	
	echo '<h3>Check Tabelle eseguito, vedi mail per problemi eventuali ...</h3>';
	ob_flush(); flush();
	
	
/* Invio rapporto via mail 			 */
	$posta = new Backup_Invio_Mails($status, $backupDatabase->dbNameSql);
	$posta->Mail_database();
	
	
/*  backup dei files
 	Alcuni file e cartelle sono esclusi dalla compressione, vedi class  OPAR->no_zip  	*/
	$bakSite = new Backup_Sito();
	$bakSite->Main();

	
	echo '<h3>Compressione files eseguita ...</h3>';
	ob_flush(); flush();
	
/*	Crea il file con la lista dei files compressi	*/
	$bakSite->ListaFiles();
	
	echo '<h3>Creata Lista dei files compressi ... </h3>';
	ob_flush(); flush();
	

/*	invio rapporto seconda mail	*/
	$posta->Mail_files();
	
	exit('<h3>Terminato il Backup del database e dei files del sito web '.$_SERVER['HTTP_HOST'] . '</h3>');
