<?php
/*	www.edilweb.eu		Agosto 2015 	-	Aprile 2017	*/

defined('RADICE') or die('<h3>404 - File not found</h3>');

/**
 * Invia emails
 */
Class Backup_Invio_Mails{
	private $status = '';
	private $nomeBackup = '';

	public function __construct($status = '', $nomeBackup = ''){
		$this->status = $status;
		$this->nomeBackup = $nomeBackup;
	}


	public function Mail_database(){
		$par = new OPAR();

		include INCLUDE_DIR . 'class.phpmailer.php';
		$mail = new PHPMailer(false, INCLUDE_DIR);

		$msg  = "\n";
		$msg .= 'Il backup del database  stato eseguito: comando di sistema mysqldump'."\n";
		$msg .= 'con status = '. $this->status ."\n";
		$msg .= 'Nome file dump: '. OUTPUT_DIR . $this->nomeBackup ."\n";
		$msg .= "\n";
		
		if (Backup_Database::$phpDumpExecute == true){
			if (Backup_Database::$phpDumpError == null  &&  Backup_Database::$PDOdumpError == null){
				$esito = 'OK';
			}
			else {
				$esito = 'Eccezioni ';
			}
			
			$msg .= 'Il backup del database  stato eseguito da php'."\n";
			$msg .= 'con esito = '. $esito . "\t". Backup_Database::$phpDumpError . "\t" . Backup_Database::$PDOdumpError ;
			$msg .= 'Nome file dump: '. Backup_Database::$dbNameSqlPhp ."\n";
		}
		
		$msg .= "\n";
		$msg .= '-----	Fine backup database	-----' ."\n";
		$msg .= "\n";
		
		foreach (Backup_Database::$outputMsg as $tab){ $msg .= $tab . "\n"; }

		/*	parametri invio. funzione mail() , no SMTP	*/
		$mail->IsMail();
		$mail->Helo = 'localhost.localdomain';
		$mail->SetFrom($par->from_mail, $par->from_name);
		$mail->Subject = 'Backup Database di: ' . $_SERVER["HTTP_HOST"];
		$mail->Body = $msg;
		$mail->AddAddress($par->mail_destinatario, $par->nome_destinatario);

		if(!$mail->Send()) {	echo  "<br>Errore!: ".$mail->ErrorInfo; }
	}



	public function Mail_files(){
		$par = new OPAR();
		$mail = new PHPMailer(false, INCLUDE_DIR);

		$msg  = "\n";
		$msg .= 'Il backup dei files del sito  stato eseguito'."\n";
		$msg .= 'file backup      : '. OUTPUT_DIR . $par->nomeFileBackup ."\n";
		$msg .= 'file index backup: '. OUTPUT_DIR . $par->nomeListaFiles;
		$msg .= "\n";
		$msg .= '-----	Fine backup files	-----' ."\n";
		$msg .= "\n";
		
		$mail->IsMail();
		$mail->Helo = 'localhost.localdomain';
		$mail->SetFrom($par->from_mail, $par->from_name);
		$mail->Subject = 'Backup files e directory di: ' . $_SERVER["HTTP_HOST"];
		$mail->Body = $msg;
		$mail->AddAddress($par->mail_destinatario, $par->nome_destinatario);

		if(!$mail->Send()) {	echo  "<br>Errore!: ".$mail->ErrorInfo; }
	}
}


/**
 * Esegue il bckup dei file e delle cartelle del sito.
 * I file e le cartelle esclusi dalla compressione sono da copiare manualmente
 */
class Backup_Sito {
	use BackTrait;
	
	static $arrayZips = array();
	
	public function Main(){
		/*	directory e files no zip, esclusi	*/
		$par = new OPAR();
		$noBak = Array('.', '..');
		foreach ($par->no_zip as $file){ $noBak[] = $file; }
		
		/*	backup	*/
		if (file_exists(OUTPUT_DIR . $par->nomeFileBackup)) {
			unlink(OUTPUT_DIR . $par->nomeFileBackup);
		}
		
	
		/*	file zip da creare	*/
		$vol = 1;
		$zipPath = OUTPUT_DIR . strval($vol).'_'. $par->nomeFileBackup;
		
		$zip = new ZipArchive();

		$zip->open($zipPath, ZipArchive::CREATE);
		
		self::$arrayZips[] = $zipPath;

		
		/*	posizione di avvio del backup	*/
		if (!is_dir(RADICE)) {
			throw new Exception('Directory ' . RADICE . ' does not exist');
		}

		$dirName = RADICE;
		if (substr($dirName, -1) != DIRECTORY_SEPARATOR) {
			$dirName .= DIRECTORY_SEPARATOR;
		}

		$dirStack = array($dirName);

		/*	Find the index where the last dir starts	*/
		$cutFrom = strrpos(substr($dirName, 0, -1), DIRECTORY_SEPARATOR)+1;

		$this->timeTest(true);
		/*---------------------	*/
		$volFiles = 0;
		$volBytes = 0;

		
		/*	Cicla directory e files, tranne quelli esclusi			 */
		while (!empty($dirStack)) {

			$currentDir = array_pop($dirStack);
			$filesToAdd = array();

			$dir = dir($currentDir);
			while (false !== ($node = $dir->read())) {

				if (in_array($node, $noBak)) {
					continue;
				}

				if (is_dir($currentDir . $node)) {
					array_push($dirStack, $currentDir . $node . DIRECTORY_SEPARATOR);
				}
				if (is_file($currentDir . $node)) {
					$filesToAdd[] = $node;
				}
			}


			$localDir = substr($currentDir, $cutFrom);
			$zip->addEmptyDir($localDir);
			/*---------------*/
			$this->timeTest();
			$volFiles += 1;
			
			foreach ($filesToAdd as $file) {
				$zip->addFile($currentDir . $file, $localDir . $file); 
				$this->timeTest();	
				
				/*----------------------------------------*/
				
				$statFile = stat($currentDir.$file);
				$volFiles += 1;
				$volBytes += $statFile['size'];

				if (($volFiles > 9000) || ($volBytes > 70000000)){					
					$this->timeTest(true);
					
					$zip->close(); unset($zip);
					
					$zip = new ZipArchive();
					$vol += 1;
					
					$zipPath = OUTPUT_DIR. strval($vol).'_' .$par->nomeFileBackup;					
					if (is_file($zipPath)){unlink($zipPath);}
					
					$zip->open($zipPath, ZipArchive::CREATE);
					self::$arrayZips[] = $zipPath;
					
					$this->timeTest(true);
					
					$volFiles = 0;
					$volBytes = 0;
				}

				
			}
			
		}

		$this->timeTest(true);
		$zip->close();
		
		$this->DeleteOldZip();
	}
	
	
	/**
	 * Crea il file testo con la lista dei file compressi		 */
	function ListaFiles(){

		$par = new OPAR();
		/*	file del listato	*/
		$indexBak = OUTPUT_DIR . $par->nomeListaFiles;
		
		if (file_exists($indexBak)){unlink($indexBak);}
		
		$handle = fopen($indexBak, 'a');		
				
		foreach (self::$arrayZips as $zipPath){
			$zip = new ZipArchive();
	
			$zip->open($zipPath);
			
			$cutFrom = strrpos(substr($zipPath, 0, -1), DIRECTORY_SEPARATOR)+1;
			
			fwrite($handle, "\n");
			fwrite($handle, substr($zipPath, $cutFrom) .' :file compressi: '.$zip->numFiles . "\n");
			fwrite($handle, "\n");
			
			for ($i = 0; $i < $zip->numFiles; $i++) {
				$filename = $zip->getNameIndex($i);
				fwrite($handle, $filename . "\n");
			}
			
			fwrite($handle, "\n");		
			fwrite($handle, '--- -- --- '. "\n");
			
			$zip->close();
			unset($zip);
		}	
		
		fwrite($handle, "\n");
		fwrite($handle, '--- fine index backup --- '. "\n");
		
		fclose($handle);
	}
	
	
	
	
	function DeleteOldZip(){
		
		$this->timeTest(true);
		
		if (! is_dir(OUTPUT_DIR)) {return ;}
	
		$cart = dir(OUTPUT_DIR);

		while ($file = $cart->read()){
			if ($file == '.' || $file == '..') {continue;}

			$estensione = strrchr($file,".");
			
			if (!preg_match('/.zip/i', $estensione)){ continue;}
			
			if (!in_array(OUTPUT_DIR . $file, self::$arrayZips)){
				unlink(OUTPUT_DIR . $file);
			}
			
		}
	
		$cart->close();

	}
		
}



/**
 * Backup_Database class 	
*/

class Backup_Database {
	use BackTrait;
	
	/**
	 * Host where database is located	 */
	public $host = '';

	/**
	 * Username used to connect to database	 */
	public $username = '';

	/**
	 * Password used to connect to database	 */
	public $passwd = '';

	/**
	 * Database to backup	 */
	public $dbName = '';

	/**
	 * Database charset	 */
	public $charset = '';

	/**
	 * Nome file .sql del database  	 */
	public $dbNameSql = '';
	static $dbNameSqlPhp = '';
	
	/**
	 * PDO dns			 */
	public $dsn = '';	

	/**
	 * Connessione	 */
	private $conn = '';
	
	/**
	 * Array 	 */
	static $outputMsg = Array('Check Tabelle. Problemi potenziali: ');
	
	/**
	 * elaborazione in corso		 */
	static $prog = '';
	
	/**
	 *	mysqldump-php		 */
	static $phpDumpExecute = FALSE;
	static $phpDumpError   = '';
	static $PDOdumpError   = '';
	
	
	/**
	 * Constructor initializes   	 */
	function __construct($charset = '') {
		$par = new OPAR();
		
		$this->host     = $par->host;
		$this->username = $par->user;
		$this->passwd   = $par->psw;
		$this->dbName   = $par->dbase;
		$this->charset  = $charset;
		$this->dbNameSql = $this->dbName . '_dump'  .'.sql';
		
		self::$dbNameSqlPhp = OUTPUT_DIR . $par->dbase . '_dump_php.sql';
		
		$this->dsn = sprintf("mysql:host=%s;dbname=%s", $par->host, $par->dbase);
		
		if (file_exists($this->dbNameSql)){
			unlink($this->dbNameSql);
		}
		if (file_exists(self::$dbNameSqlPhp)){
			unlink(self::$dbNameSqlPhp);
		}
		
		/*	connect	*/
		$this->conn = $par->Connessione();
		
		self::$prog = time();
	}


	/**
	 * Check tabelle del database.	 */
	public function Ottimizza_Tabelle(){
		$par = new OPAR();

		$tables = $par->Showi_tables($par->dbase, $this->conn);

		foreach ($tables as $tab) {

			$sql = "CHECK TABLE `{$tab}`";
			$result = mysqli_query($this->conn, $sql);
			if (mysqli_num_rows($result) > 0){
				while ($tab_check = mysqli_fetch_assoc($result)) {
					if ($tab_check['Msg_type'] != 'status'){
						self::$outputMsg[] = json_encode($tab_check);
					}
				}
			}
			else {
				self::$outputMsg[] = 'CHECK TABLE non riuscito';
			}
			
			$this->timeTest();
		}
	}
	
	
	/**
	 * Dump database con mysqldump di sistema
	 */
	function SystemDump(){
		system('mysqldump -u '. $this->username .' -p'. $this->passwd .' '. $this->dbName .' > '. OUTPUT_DIR . $this->dbNameSql, $status);
		
		$status == null ? $status = 'OK' : $status = 'Errore del comando di sistema mysqldump. Vedi log file del server.';
		return $status;
	}

}

/**
 * 2017 - funzioni comuni
 */
trait BackTrait {
	function timeTest($o = false){
		$ora = time() - Backup_Database::$prog;		/*  file_put_contents(OUTPUT_DIR . 'timeControl.txt', time() . "\n", FILE_APPEND);  */	
		
		if (!$o){
			if ($ora > 15){
				echo '<span> ... working ... </span>';
				ob_flush(); flush();
				
				//@set_time_limit(ini_get('max_execution_time'));
				@set_time_limit(0);
				
				Backup_Database::$prog = time();
			}
		}
		else {
			echo '<span> ... working ... </span>';
			ob_flush(); flush();
			
			//@set_time_limit(ini_get('max_execution_time'));
			@set_time_limit(0);
			
			Backup_Database::$prog = time();
		}
	}
	
}