<?php
/**
 * install.php	April 2017	-	http://edilweb.eu
 *
 * Lo script  di libero uso, ma viene fornito come , senza garanzie o assunzioni di responsabilit.
 *
 * This program is distributed in the hope that it will be useful - WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.
 */

class BackInstall {
	
	static $idPage = '';
	
	static $hostDb = '';
	static $nameDb = '';
	static $userDb = '';
	static $passDb = '';
	
	static $nomeDump = '';
	static $nomeZip = '';
	static $nomeIndex = '';
	static $mailFrom = '';
	static $mailTo = '';

	static $urlBackup = '';
	
	function __construct(){
		header('Content-Type: text/html; charset=ISO-8859-15');
		
		if((! $this->TestInit())){
			$this->Work();
		}
		else {
			$this->Initial();
		}

	}
	
	
	
	private function Initial(){
		self::$idPage = $this->IdPagina();
		
		self::$nomeDump = '{your Db name}_dump[_php].sql';
		self::$nomeZip = 'Backup_'.$_SERVER['HTTP_HOST'].'.zip';
		self::$nomeIndex = 'ListaFiles_'.$_SERVER['HTTP_HOST'].'.txt';
		self::$mailFrom = 'Backup.Script@'.$_SERVER['HTTP_HOST'];
		self::$mailTo = 'Admin@'.$_SERVER['HTTP_HOST'];
		
		echo $this->HTMLinitial();
	}
	
	
	private function TestInit(){
		if (null == session_id()) {session_start();}
		
		if (! isset($_SESSION['idPage'])) {return true;}
		
		switch (filter_input(INPUT_POST, 'idPagina', FILTER_SANITIZE_STRING)) {
			case $_SESSION['idPage']:
				return false;
			default:
				return true;
		}
	}
	
	
	private function IdPagina(){
		if (null == session_id()) {session_start();}
		return($_SESSION['idPage'] = uniqid('bkInst_'));
	}
	
	
	
	private function TestConfirm(){
		switch (filter_input(INPUT_POST, 'confirm', FILTER_SANITIZE_STRING)) {
			case 'Confirm':
				return true;
			case 'Cancel':
				exit('<h3>Installazione Sospesa</h3>');
			default:
				return false;
		}
	}
	
	
	
	private function HTMLinitial(){
		$dump = self::$nomeDump;
		$zip = self::$nomeZip;
		$idx = self::$nomeIndex;
		$from = self::$mailFrom;
		$to = self::$mailTo;
		$idPagina = self::$idPage;
		
		$html = <<<HTM
<!DOCTYPE html>
<html dir="ltr" lang="it">
<head>
  	<meta content="text/html; charset=UTF-8" http-equiv="content-type">
  	<title>Installer Backup script</title>
  	<meta content="Aprile 2017 - Installer script di Backup Sito - www.edilweb.eu" name="description">
	<meta name=viewport content="width=device-width, initial-scale=1">
	<style type="text/css">
		body {font-family:calibri,verdana,arial,times new roman;}
		form input{height: 19px;margin-bottom:10px; padding-left:1px; padding-top:2px; padding-bottom: 2px;}
		legend span{display:inline-block; font-weight:bold; text-align:center;width:150px !important;}
		.bord{box-shadow:0px 2px 2px 0px RGBA(168,163,168,1); background-color:yellow; min-height:80px; width:100%;}
		.bord.footer{border-top-color:#a09797; border-top-style:solid; border-top-width:1px;}
		.header{margin-top:0; padding-top:10px; text-align:center;}
		.sp_20{display:block; margin-top: -20px; text-align:center;}
		.btn{height:24px; padding:2px 5px 2px 5px;}
		.sp64_1{font-size: 20px;}
		.p64{line-height: 150%; margin-left:10px;}
		.div64_1 {background:#DCE6E5 /*#B3D3CF*/; border-color:#a09797; border-style: solid;border-width: 1px; max-width:600px; width: 100%; height: inherit;margin-top:22px;margin-right: auto; margin-left: auto;}
		.fldDb{margin:10px;}
		.fldDb span{display:inline-block; text-align:center; width:130px;}
		.iptReadOnly:hover{cursor: no-drop;}
	</style>  
</head>
<body>
<div class="div64_1">
	<div class="bord">
		<h1 class="header">Backup Installer</h1><span class="sp_20">Selezione parametri backup</span>
	</div>
	<p class="p64">
		<span class="sp64_1">Inserire i giusti valori nei campi. Sono tutti necessari.</span><br>
	</p>
	<form method="post" action="{$_SERVER['PHP_SELF']}">
		<fieldset class="fldDb">
			<legend><span>Database</span></legend>
			<label><span>Database Host</span></label><input type="text" name="hostDb" value="localhost" required><br>
			<label><span>Database Nome</span></label><input type="text" name="nameDb" autofocus required><br>
			<label><span>Database User</span></label><input type="text" name="userDb" required><br>
			<label><span>Database Password</span></label><input type="password" name="passDb" required>
		</fieldset>
		<fieldset class="fldDb">
			<legend><span>Files output backup</span></legend>
			<label><span>file Dump</span></label><input class="iptReadOnly" type="text" name="dumpFile" readonly value="{$dump}"><br>
			<label><span>file Zip</span></label><input type="text" name="zipFile" value="{$zip}" required><br>
			<label><span>file Index zip</span></label><input type="text" name="indexFile" value="{$idx}" required>
		</fieldset>
		<fieldset class="fldDb">
			<legend><span>Emails</span></legend>
			<label><span>email Mittente</span></label><input type="email" name="mailFrom" value="{$from}" required><br>
			<label><span>email Destinatario</span></label><input type="email" name="mailTO" value="{$to}" required>
			<input type="hidden" name="idPagina" value="{$idPagina}">
		</fieldset>
		<fieldset class="fldDb">
			<input class="btn" type="submit">
			<input class="btn" type="reset" value=" Reset ">
		</fieldset>
	</form>
	<p></p>
	<div class="bord footer">
		<p class="p64" style="margin-bottom:0;"><a href="http://edilweb.eu">EdilWeb.eu</a></p>
	</div>
</div>
</body>
</html>
HTM;
		return $html;
	}
	
	/*		-----------------------		*/
	
	private function HTMLconfirm(){
		$host = self::$hostDb;
		$nameDb = self::$nameDb;
		$userDb = self::$userDb;
		$passDb = self::$passDb;
		$dump = self::$nomeDump;
		$zip = self::$nomeZip;
		$idx = self::$nomeIndex;
		$from = self::$mailFrom;
		$to = self::$mailTo;
		
		$urlBak = self::$urlBackup;
		
		if (null == session_id()) {session_start();}

		
		$htmDue = <<<HTM
<!DOCTYPE html>
<html dir="ltr" lang="it">
<head>
  	<meta content="text/html; charset=UTF-8" http-equiv="content-type">
  	<title>Installer Backup script - Conferma</title>
  	<meta content="Aprile 2017 - Installer script di Backup Sito - www.edilweb.eu" name="description">
	<meta name=viewport content="width=device-width, initial-scale=1">
	<style type="text/css">
		body {font-family:calibri,verdana,arial,times new roman;}
		form input{height: 19px;margin-bottom:10px; padding-left:1px; padding-top:2px; padding-bottom: 2px;}
		legend span{display:inline-block; font-weight:bold; text-align:center;width:150px !important;}
		.bord{box-shadow:0px 2px 2px 0px RGBA(168,163,168,1); background-color:yellow; min-height:80px; width:100%;}
		.bord.footer{border-top-color:#a09797; border-top-style:solid; border-top-width:1px;}
		.header{margin-top:0; padding-top:10px; text-align:center;}
		.sp_20{display:block; margin-top: -20px; text-align:center;}
		.btn{height:24px; padding:2px 5px 2px 5px;}
		.sp64_1{font-size: 20px;}
		.p64{line-height: 150%; margin-left:10px;}
		.div64_1 {background:#DCE6E5 /*#B3D3CF*/; border-color:#a09797; border-style: solid;border-width: 1px; max-width:600px; width: 100%; height: inherit;margin-top:22px;margin-right: auto; margin-left: auto;}
		.fldDb{margin:10px;}
		.fldDb span{display:inline-block; text-align:center; width:130px;}
		.iptReadOnly:hover{cursor: no-drop;}
	</style>
</head>
<body>
<div class="div64_1">
	<div class="bord">
		<h1 class="header">Backup Installer</h1><span class="sp_20">Conferma parametri backup</span>
	</div>
	<p class="p64">
		<span class="sp64_1">Valori selezionati.</span><br>
	</p>
	<p class="p64">
	Database Host: <b>{$host}</b> <br>
	Database Nome: <b>{$nameDb}</b> <br>
	Database User: <b>{$userDb}</b> <br>
	Database Pssw: <b>{$passDb}</b> <br>
	</p>
	<p></p>
	<p class="p64">
	File Sql (dump db): <b>automatico</b><br>
	File Zip: <b>{$zip}</b><br>
	File Index zip: <b>{$idx}</b><br>
	</p>
	<p></p>
	<p class="p64">
	email Mittente: <b>{$from}</b><br>
	email Destinatario: <b>{$to}</b><br>
	</p>
	<p></p>
	<p class="p64">
		<span>Conserva l'indirizzo del backup script:</span><br>
		<span><b>{$urlBak}</b></span><br>
	</p>
	<hr>
	<form method="post" action="{$_SERVER['PHP_SELF']}">
		<p class="p64">
			<input type="hidden" name="idPagina" value="{$_SESSION['idPage']}">
			<input type="hidden" name="confirm" value="Confirm">
			
			<span class="sp64_1">Confermali e avvia il primo backup </span>&nbsp;
			<input class="btn" type="submit" value=" OK CONFERMO ">
		</p>
	</form>
	<form method="post" action="{$_SERVER['PHP_SELF']}">
		<p class="p64">
			<input type="hidden" name="idPagina" value="{$_SESSION['idPage']}">
			<input type="hidden" name="confirm" value="Cancel">
			
			<span class="sp64_1">Sospendi l'installazione e Riavviala </span>&nbsp;
			<input class="btn" type="submit" value=" CANCEL ">
		</p>
	</form>
	<p></p>
	<div class="bord footer">
		<p class="p64" style="margin-bottom:0;"><a href="http://edilweb.eu">EdilWeb.eu</a></p>
	</div>
</div>
</body>
</html>
HTM;
		return $htmDue;
	}
	
	
	
	private function Work(){
				
		if (! $this->TestConfirm()){
			$this->WorkParam();
			echo $this->HTMLconfirm();
		}
		else {
			$this->WorkConfirm();
		}
				
	}
	
	
	
	private function WorkParam(){
		self::$hostDb = filter_input(INPUT_POST, 'hostDb', FILTER_SANITIZE_STRING);
		self::$nameDb = filter_input(INPUT_POST, 'nameDb', FILTER_SANITIZE_STRING);
		self::$userDb = filter_input(INPUT_POST, 'userDb', FILTER_SANITIZE_STRING);
		self::$passDb = filter_input(INPUT_POST, 'passDb', FILTER_SANITIZE_STRING);
		
		self::$nomeZip = filter_input(INPUT_POST, 'zipFile', FILTER_SANITIZE_URL);
		self::$nomeIndex = filter_input(INPUT_POST, 'indexFile', FILTER_SANITIZE_URL);
		
		self::$mailFrom = filter_input(INPUT_POST, 'mailFrom', FILTER_SANITIZE_EMAIL);
		self::$mailTo = filter_input(INPUT_POST, 'mailTO', FILTER_SANITIZE_EMAIL);
		
		
		$a = file_get_contents(RADICE . '/backup_sito/prote/par.php');
		
		$b = explode(PHP_EOL, $a);
		
		$c = array();
		
		foreach ($b as $value) {
			if (preg_match('/public \$host/', $value)){
				$c[] = ' public $host = '.'"'.self::$hostDb.'";';
			}
			elseif (preg_match('/public \$dbase/', $value)){
				$c[] = ' public $dbase = '.'"'.self::$nameDb.'";';
			}
			elseif (preg_match('/public \$user/', $value)){
				$c[] = ' public $user = '.'"'.self::$userDb.'";';
			}
			elseif (preg_match('/public \$psw/', $value)){
				$c[] = ' public $psw = '.'"'.self::$passDb.'";';
			}
			elseif (preg_match('/public \$nomeFileBackup/', $value)){
				$c[] = ' public $nomeFileBackup = '.'"'.self::$nomeZip.'";';
			}
			elseif (preg_match('/public \$nomeListaFiles/', $value)){
				$c[] = ' public $nomeListaFiles = '.'"'.self::$nomeIndex.'";';
			}
			elseif (preg_match('/public \$from_mail/', $value)){
				$c[] = ' public $from_mail = '.'"'.self::$mailFrom.'";';
			}
			elseif (preg_match('/public \$mail_destinatario/', $value)){
				$c[] = ' public $mail_destinatario = '.'"'.self::$mailTo.'";';
			}
			else {
				$c[] = $value;
			}
		}
		
		$d = implode(PHP_EOL, $c);
		
		file_put_contents(RADICE . '/backup_sito/prote/par_tmp.php', $d);
		
		/*		---		*/
		self::$urlBackup = 'http://'.$_SERVER['HTTP_HOST'].'/backup_sito/backup.php';
		
		if (null == session_id()) {session_start();}
		
		$_SESSION['urlBackup'] = self::$urlBackup;

	}
	
	
	
	private function WorkConfirm(){
		unlink(RADICE . '/backup_sito/prote/par.php');
		
		rename(RADICE . '/backup_sito/prote/par_tmp.php', RADICE . '/backup_sito/prote/par.php');
		
		sleep('1');
		
		if (null == session_id()) {session_start();}
		
		$a = sprintf("Location:%s",$_SESSION['urlBackup']);

		header($a);
		
		unlink(RADICE . '/backup_sito/install.php');
		
		exit();
	}

	
}

/*			MAIN		*/

	define('RADICE', substr(__DIR__, 0, strripos(__DIR__, DIRECTORY_SEPARATOR)));
	
	$install = new BackInstall();
	

